/*
改程序为口令模式，先说 xiao jie ，然后说具体关键词 如广州，、
可通过串口来查看识别结果
接线定义:
3.3V GND 选一组接就行
  3V3--3.3V
  GND--GND
  SCK--A5
  MI--A4
  MO--A3
  CS--A2
  RST--D5
  IRQ--D3
  WR--GND
*/
#include "LD3320.h"




#include"tables.h"

mytable voc_tbl0={
     "xiao jie",
    "dai ma ce shi",
    "ce shi wan bi",
    ""
};

mytable voc_tbl1={
    "bei jing",
    "shang hai",
    "kai deng",
    "guan deng",
    ""
};

mytable voc_tbl2={
    "guang zhou",
    "shen zhen",
    "xiang zuo zhuan",
    "xiang you zhuan",
    ""
};

mytable voc_tbl3={
    "da kai kong tiao",
    "guan bi kong tiao",
    "hou tui",
    ""
};

mytable *var_tbl=(mytable*)voc_tbl2;
cLinkedTables *voice_tables;

IRAM_ATTR unsigned the_debug_data, the_debug_cnt;

bool Timeout(unsigned ms, unsigned &store_start_time_us, bool one_shot=false, bool one_shot_lasting=false){
    if (one_shot && !store_start_time_us) return one_shot_lasting;
    if (int(micros())-int(ms*1000+store_start_time_us)>=0){
        store_start_time_us=one_shot? 0: micros();
        return true;
    }
    return false;
}




LD3320 WE;

u8 nAsrStatus=0;
u8 nAsrRes=0;
extern u8  ucRegVal;
u8 flag=0;


void setup() {
  Serial.begin(115200);
  delay(5000);
  WE.LD3320_IO_Init();
  WE.LD_Reset();
  attachInterrupt(13, ProcessInt, FALLING);
  nAsrStatus = LD_ASR_NONE;    //初始状态：没有在作ASR
  SCS_0;
  Serial.println("\r\nStart\r\n");
}




unsigned my_status_cnt[12]={0};

void loop() {


////////////////////////////////////////////////////////////////////////////////
#if (MY_VERSION)
        static unsigned abc=1;
        if (abc){
            abc=0;

            voice_tables=new cLinkedTables;
            voice_tables->assignTable(voc_tbl0);
            voice_tables->addTable(voc_tbl1);
            voice_tables->addTable(voc_tbl2);
            voice_tables->addTable(voc_tbl3);
            voice_tables->debug_dumpTables();

            /*cLinkedTables *vp=voice_tables->getFirst();
            for (int i=vp->nums(); i--;vp->mov2Nxt(vp)){
                printf("%X %X %X", (unsigned)(vp->prv), (unsigned)vp, (unsigned)(vp->nxt));
                printf(" %X %X %X\r\n", (unsigned)(vp->getT()), (unsigned)(*(vp->getT())), (unsigned)((*(vp->getT()))[0]));
            }
            printf(" %x\r\n", (unsigned)F("\r\n"));*/
            //var_tbl=(mytable*)&voc_tbl1;
        }
#endif
////////////////////////////////////////////////////////////////////////////////


    //  x     0             57      0      0      1       32      24       32         24     0     32
    // IDLE, RUNNING, RUNNING1, ERROR, ERROR1, *NONE, *NONE1, *NONE2, FOUNDOK, #FOUNDZERO, #DF, success.
    //    0,       1,        2,     3,      4,     5,      6,      7,       8,          9,  10,      11.
    extern unsigned my_status_cnt[12];

    switch (nAsrStatus){
        case LD_ASR_IDLE: my_status_cnt[0]++; break;
        case LD_ASR_RUNING: my_status_cnt[1]++; nAsrStatus=LD_ASR_IDLE; break;
        case LD_ASR_RUNING1: my_status_cnt[2]++; nAsrStatus=LD_ASR_IDLE; break;
        case LD_ASR_ERROR: my_status_cnt[3]++; nAsrStatus=LD_ASR_IDLE; break;
        case LD_ASR_ERROR1: my_status_cnt[4]++; nAsrStatus=LD_ASR_IDLE; break;
        case LD_ASR_NONE:
            my_status_cnt[5]++;
            if (WE.RunASR()) nAsrStatus=LD_ASR_RUNING1; // 启动一次ASR识别流程：ASR初始化，ASR添加关键词语，启动ASR运算
            else {
                nAsrStatus=LD_ASR_ERROR1;
                Serial.println("Initialized failed and halt.");
            }
            break;
        case LD_ASR_NONE1:
            my_status_cnt[6]++;
            if (WE.RunASR()) nAsrStatus=LD_ASR_RUNING1; // 启动一次ASR识别流程：ASR初始化，ASR添加关键词语，启动ASR运算
            else {
                nAsrStatus=LD_ASR_ERROR1;
                Serial.println("Initialized failed and halt.");
            }
            break;
        case LD_ASR_NONE2:
            my_status_cnt[7]++;
            if (WE.RunASR()) nAsrStatus=LD_ASR_RUNING1; // 启动一次ASR识别流程：ASR初始化，ASR添加关键词语，启动ASR运算
            else {
                nAsrStatus=LD_ASR_ERROR1;
                Serial.println("Initialized failed and halt.");
            }
            break;
        case LD_ASR_FOUNDOK: // 一次ASR识别流程结束，去取ASR识别结果
            my_status_cnt[8]++;
            nAsrRes=WE.LD_GetResult(); // 获取结果
            User_Modification(nAsrRes);
            nAsrStatus=LD_ASR_NONE1;
            break;
        case LD_ASR_FOUNDZERO: my_status_cnt[9]++; nAsrStatus=LD_ASR_NONE2; break;
        default: my_status_cnt[10]++; nAsrStatus=LD_ASR_NONE2; break;
    }


    static unsigned tmo=micros();
    if (Timeout(1800, tmo)){
        Serial.printf("%u %u %u\r\n", nAsrStatus, the_debug_data, the_debug_cnt);
        for (int i=1; i<12; i++) Serial.printf("% 6d ", my_status_cnt[i]);
        Serial.printf("\r\n\r\n");
    }


}

void User_Modification(u8 dat)
{
#if 0


  if(dat !=0)
  {
    flag=1;
    Serial.println("Received\r\n");
  }
  /*else */if(flag)
  {
    flag=0;

    my_status_cnt[11]++;
    
    switch(nAsrRes)      /*对结果执行相关操作,客户修改*/
    {
      case CODE_CMD:
          Serial.println("xiao jie");
                        break;
      case CODE_DMCS:     /*命令“代码测试”*/
          Serial.println("dai ma ce shi\r\n"); /*text.....*/
                        break;
      case CODE_CSWB:     /*命令“测试完毕”*/
          Serial.println("ce shi wan bi\r\n"); /*text.....*/
                        break;
      
      case CODE_1KL1:  /*命令“北京”*/
          Serial.println("bei jing\r\n"); /*text.....*/
                        break;
      case CODE_1KL2:   /*命令“上海”*/
    
          Serial.println("shang hai\r\n"); /*text.....*/
                        break;
      case CODE_1KL3:  /*命令“开灯”*/
          Serial.println("kai deng\r\n"); /*text.....*/
                        break;
      case CODE_1KL4:   /*命令“关灯”*/        
          Serial.println("guan deng\r\n"); /*text.....*/
                        break;
      
      case CODE_2KL1:  /*命令“....”*/
          Serial.println("guang zhou\r\n"); /*text.....*/
                        break;
      case CODE_2KL2:  /*命令“....”*/
          Serial.println("shen zhen\r\n"); /*text.....*/
                        break;
      case CODE_2KL3:  /*命令“....”*/
          Serial.println("xiang zuo zhuan\r\n"); /*text.....*/
                        break;
      case CODE_2KL4:  /*命令“....”*/
          Serial.println("xiang you zhuan\r\n"); /*text.....*/
                              break;
            
      case CODE_3KL1:  /*命令“....”*/
          Serial.println("da kai kong tiao\r\n"); /*text.....*/
                        break;
      case CODE_3KL2:  /*命令“....”*/
          Serial.println("guan bi kong tiao\r\n"); /*text.....*/
                        break;
      case CODE_5KL1:  /*命令“....”*/
          Serial.println("hou tui"); /*text.....*/
                        break;
  //    case CODE_3KL4:  /*命令“....”*/
  //        Serial.println("\"代码测试\"识别成功"); /*text.....*/
  //                      break;
  //          
  //          case CODE_4KL1:  /*命令“....”*/
  //              Serial.println("O"); /*text.....*/
  //                            break;
  //          case CODE_4KL2:  /*命令“....”*/
  //              Serial.println("P"); /*text.....*/
  //                            break;
  //          case CODE_4KL3:  /*命令“....”*/
  //              Serial.println("Q"); /*text.....*/
  //                            break;
  //          case CODE_4KL4:  /*命令“....”*/
  //              Serial.println("R"); /*text.....*/
  //                            break;
      
      default:
        my_status_cnt[11]--;
        break;
    }
  }
  else  
  {
    Serial.println("Error\r\n"); /*text.....*/  
  }



#else






    my_status_cnt[11]++;
    
    switch(nAsrRes)      /*对结果执行相关操作,客户修改*/
    {
      case CODE_CMD:
          Serial.println("xiao jie");
                        break;
      case CODE_DMCS:     /*命令“代码测试”*/
          Serial.println("dai ma ce shi\r\n"); /*text.....*/
                        break;
      case CODE_CSWB:     /*命令“测试完毕”*/
          Serial.println("ce shi wan bi\r\n"); /*text.....*/
                        break;
      
      case CODE_1KL1:  /*命令“北京”*/
          Serial.println("bei jing\r\n"); /*text.....*/
                        break;
      case CODE_1KL2:   /*命令“上海”*/
    
          Serial.println("shang hai\r\n"); /*text.....*/
                        break;
      case CODE_1KL3:  /*命令“开灯”*/
          Serial.println("kai deng\r\n"); /*text.....*/
                        break;
      case CODE_1KL4:   /*命令“关灯”*/        
          Serial.println("guan deng\r\n"); /*text.....*/
                        break;
      
      case CODE_2KL1:  /*命令“....”*/
          Serial.println("guang zhou\r\n"); /*text.....*/
                        break;
      case CODE_2KL2:  /*命令“....”*/
          Serial.println("shen zhen\r\n"); /*text.....*/
                        break;
      case CODE_2KL3:  /*命令“....”*/
          Serial.println("xiang zuo zhuan\r\n"); /*text.....*/
                        break;
      case CODE_2KL4:  /*命令“....”*/
          Serial.println("xiang you zhuan\r\n"); /*text.....*/
                              break;
            
      case CODE_3KL1:  /*命令“....”*/
          Serial.println("da kai kong tiao\r\n"); /*text.....*/
                        break;
      case CODE_3KL2:  /*命令“....”*/
          Serial.println("guan bi kong tiao\r\n"); /*text.....*/
                        break;
      case CODE_5KL1:  /*命令“....”*/
          Serial.println("hou tui"); /*text.....*/
                        break;

      default:
        my_status_cnt[11]--;
        break;
    }



#endif

}

IRAM_ATTR void ProcessInt(void)
{

///////////////////////////////////////////////////////////////////////////////
    the_debug_cnt++;
///////////////////////////////////////////////////////////////////////////////

  u8 nAsrResCount=0;
  ucRegVal = WE.LD_ReadReg(0x2B);
  WE.LD_WriteReg(0x29,0) ;
  WE.LD_WriteReg(0x02,0) ;
  if((ucRegVal & 0x10)&&WE.LD_ReadReg(0xb2)==0x21&&WE.LD_ReadReg(0xbf)==0x35)     /*识别成功*/
  { 
    nAsrResCount = WE.LD_ReadReg(0xba);
    if(nAsrResCount>0 && nAsrResCount<=4) 
    {
      nAsrStatus=LD_ASR_FOUNDOK;
    }
    else
    {
      nAsrStatus=LD_ASR_FOUNDZERO;
    } 
  }                              /*没有识别结果*/
  else
  {  
    nAsrStatus=LD_ASR_FOUNDZERO;
  }
    
  WE.LD_WriteReg(0x2b, 0);
  WE.LD_WriteReg(0x1C,0);/*写0:ADC不可用*/
  WE.LD_WriteReg(0x29,0);
  WE.LD_WriteReg(0x02,0);
  WE.LD_WriteReg(0x2B,0);
  WE.LD_WriteReg(0xBA,0);  
  WE.LD_WriteReg(0xBC,0);  
  WE.LD_WriteReg(0x08,1);   /*清除FIFO_DATA*/
  WE.LD_WriteReg(0x08,0);  /*清除FIFO_DATA后 再次写0*/
}
